﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class SelectionScript : MonoBehaviour
{
    public Button start;
    public int selectionAmt;

    // list of 'Detective Selected' game objects
    public List<GameObject> yourDets;

    // list of detectives currently selected
    private List<GameObject> selected;

    // Start is called before the first frame update
    void Start()
    {
        // start is uninteractable until you've selected enough detectives
        start.interactable = false;
        selected = new List<GameObject>();
    }

    // Update is called once per frame
    void Update()
    {
        // checks if enough detectives have been selected
        if(selected.Count == selectionAmt)
        {
            start.interactable = true;
        } else
        {
            start.interactable = false;
        }
    }

    /// <summary>
    /// checks if a detective is selected and adds or removes them from the selected list.
    /// also adds them to be visible or not on the selection screen
    /// </summary>
    /// <param name="s">detective being selected</param>
    public void AddSelected(GameObject s)
    {
        // used toggle instead of button
        Toggle t = s.GetComponent<Toggle>();
        DetectiveScript det = s.GetComponent<DetectiveScript>();

        // checks if the detective is currently selected or not
        if(t.isOn == true)
        {
            selected.Add(s);
            // gets the position in the yourDets list that the detective will appear in.
            int pos = selected.Count - 1;
            // gets an array of the three sliders
            Slider[] stats = yourDets[pos].GetComponentsInChildren<Slider>();
            // sets stat values
            stats[0].value = det.DetectiveStats.Det.Stats.WeakStrongScale;
            stats[1].value = det.DetectiveStats.Det.Stats.DepravedHonorableScale;
            stats[2].value = det.DetectiveStats.Det.Stats.LazyAmbitiousScale;
            // sets name
            Text name = yourDets[pos].GetComponentInChildren<Text>();
            name.text = s.GetComponentInChildren<Text>().text;
            // change this to be the image file when we have assets
            Image icon = yourDets[pos].GetComponentInChildren<Image>();
            icon.color = s.GetComponentInChildren<Image>().color;
        }

        if(t.isOn == false)
        {
            Text sName = s.GetComponentInChildren<Text>();
            for(int i = 0; i < selected.Count; i++)
            {
                Text detName = yourDets[i].GetComponentInChildren<Text>();
                if(sName.text == detName.text)
                {
                    // resets the detective stats
                    selected.Remove(selected[i]);
                    Slider[] stats = yourDets[i].GetComponentsInChildren<Slider>();
                    stats[0].value = 0;
                    stats[1].value = 0;
                    stats[2].value = 0;
                    detName.text = " ";
                    // change this to be the image file when we have assets
                    yourDets[i].GetComponentInChildren<Image>().color = new Color(255, 255, 255);
                    break;
                    // need to get int i saved and then for everything afterwards, move it down one position in yourDets so the next selected can be added to the end
                }
            }
        }
    }
}
