﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class WitnessScript : MonoBehaviour {

    public Personality personality;

    public Vector2 knownWeakStrongScale = new Vector2(-100.0f, 100.0f);
    public Vector2 knownDepravedHonorableScale = new Vector2(-100.0f, 100.0f);
    public Vector2 knownLazyAmbitiousScale = new Vector2(-100.0f, 100.0f);

    public BoxCollider witnessCollider;

    public bool beingQuestioned, interrogated;


    // Use this for initialization
    void Start ()
    {
        witnessCollider = this.GetComponent<BoxCollider>();

        beingQuestioned = false;

	}
	
	// Update is called once per frame
	void Update ()
    {
	}

    public void makeStatement(float similarity)
    {
        float tickTime = 1.0f * (similarity / 100.0f);

        StartCoroutine(tickScaleKnowledge(tickTime));
    }

    public IEnumerator tickScaleKnowledge(float t)
    {
        float timer = t;

        while (timer > 0)
        {
            yield return new WaitForSeconds(Time.deltaTime);
            timer -= Time.deltaTime;
        }

        float whichScale = Random.Range(0.0f, 100.0f);
        
        if(whichScale < 33.3f)
        {
            narrowScale(ref knownWeakStrongScale, personality.WeakStrongScale);
        }
        else if (whichScale >= 33.3f && whichScale < 66.6f)
        {
            narrowScale(ref knownDepravedHonorableScale, personality.DepravedHonorableScale);
        }
        else if (whichScale >= 66.6f)
        {
            narrowScale(ref knownLazyAmbitiousScale, personality.LazyAmbitiousScale);
        }

        if(beingQuestioned)
        {
            StartCoroutine(tickScaleKnowledge(t));
        }
    }

    void narrowScale(ref Vector2 scale, float personalityItem)
    {
        float r = Random.Range(scale.x, scale.y);

        if(r < personalityItem && scale.x != personalityItem)
        {
            scale.x += 5;
        }
        else if(r > personalityItem && scale.y != personalityItem)
        {
            scale.y -= 5;
        }
    }
}
